#pragma once

#include <RobotAPI/libraries/armem/server/ltm/Memory.h>
#include <RobotAPI/libraries/armem/server/query_proc/base.h>

#include "../detail/CoreSegmentQueryProcessorBase.h"
#include "../detail/EntityQueryProcessorBase.h"
#include "../detail/MemoryQueryProcessorBase.h"
#include "../detail/ProviderSegmentQueryProcessorBase.h"

namespace armarx::armem::server::query_proc::ltm_server
{
    class EntityQueryProcessor :
        public ltm::detail::EntityQueryProcessorBase<armem::server::ltm::Entity, armem::wm::Entity>
    {
    protected:
        using Base =
            ltm::detail::EntityQueryProcessorBase<armem::server::ltm::Entity, armem::wm::Entity>;


    public:
        using Base::process;
    };

    class ProviderSegmentQueryProcessor :
        public ltm::detail::ProviderSegmentQueryProcessorBase<armem::server::ltm::ProviderSegment,
                                                              armem::wm::ProviderSegment,
                                                              EntityQueryProcessor>
    {
    protected:
        using Base =
            ltm::detail::ProviderSegmentQueryProcessorBase<armem::server::ltm::ProviderSegment,
                                                           armem::wm::ProviderSegment,
                                                           EntityQueryProcessor>;


    public:
        using Base::process;
    };

    class CoreSegmentQueryProcessor :
        public ltm::detail::CoreSegmentQueryProcessorBase<armem::server::ltm::CoreSegment,
                                                          armem::wm::CoreSegment,
                                                          ProviderSegmentQueryProcessor>
    {
    protected:
        using Base = ltm::detail::CoreSegmentQueryProcessorBase<armem::server::ltm::CoreSegment,
                                                                armem::wm::CoreSegment,
                                                                ProviderSegmentQueryProcessor>;


    public:
        using Base::process;
    };

    class MemoryQueryProcessor :
        public ltm::detail::MemoryQueryProcessorBase<armem::server::ltm::Memory,
                                                     armem::wm::Memory,
                                                     CoreSegmentQueryProcessor>
    {
    protected:
        using Base = ltm::detail::MemoryQueryProcessorBase<armem::server::ltm::Memory,
                                                           armem::wm::Memory,
                                                           CoreSegmentQueryProcessor>;

    public:
        using Base::process;
    };

} // namespace armarx::armem::server::query_proc::ltm_server
