#include "ClassReader.h"

namespace armarx::armem::obj::clazz
{
    std::optional<armem::clazz::ObjectClass>
    ClassReader::getObjectClass(const std::string& providerName, const ObjectID& id)
    {
        auto mid = armarx::armem::MemoryID();
        mid.memoryName = properties().memoryName;
        mid.coreSegmentName = properties().coreSegmentName;
        mid.providerSegmentName = providerName;
        mid.entityName = id.str();

        auto i = this->memoryReader().getLatestSnapshotIn(mid);

        if (i.has_value() && i->size() == 1)
        {
            auto& instance = i->getInstance(0);
            auto aron = instance.dataAs<armarx::armem::arondto::ObjectClass>();

            armem::clazz::ObjectClass objClass;
            armarx::armem::clazz::fromAron(aron, objClass);

            return objClass;
        }

        return std::nullopt;
    }

    std::string
    ClassReader::propertyPrefix() const
    {
        return "classReader.";
    }

    client::util::SimpleReaderBase::Properties
    ClassReader::defaultProperties() const
    {
        client::util::SimpleReaderBase::Properties p;
        p.memoryName = "Object";
        p.coreSegmentName = "Class";
        return p;
    }

} // namespace armarx::armem::obj::clazz
