#ifndef SKILLMEMORYGUI_H
#define SKILLMEMORYGUI_H

#include <QHBoxLayout>
#include <QSplitter>
#include <QTreeWidget>
#include <QWidget>

#include <ArmarXCore/core/logging/Logging.h>

#include "./PeriodicUpdateWidget.h"
#include "./aron_tree_widget/widgets/SkillDescriptionWidget.h"
#include "./executions/SkillExecutionTreeWidget.h"
#include "./memory/SkillManagerWrapper.h"
#include "./skill_details/SkillDetailsGroupBox.h"
#include "./skills/SkillGroupBox.h"

namespace armarx::skills::gui
{
    class SkillMemoryGUI : public QObject, public armarx::Logging
    {
        Q_OBJECT
        using This = SkillMemoryGUI;

    public:
        SkillMemoryGUI(QTreeWidget* _skillExecutionTreeWidget,
                       QLayout* _skillExecutionTreeWidgetParentLayout,
                       QGroupBox* _skillGroupBox,
                       QSplitter* _skillGroupBoxParentLayout,
                       QGroupBox* _skillDetailGroupBox,
                       QSplitter* _skillDetailGroupBoxParentLayout,
                       QHBoxLayout* _updateWidgetLayout,

                       QWidget* skillDescription,
                       QLayout* skillDescriptionParentLayout,

                       std::shared_ptr<SkillManagerWrapper> _memory);

    public slots:
        /**
         * @brief Resets all widgets when disconnecting
         */
        void resetGui();

    private:
        void setupUi();
        void connectSignals();

        SkillExecutionTreeWidget* skillExecutionTreeWidget = nullptr;
        SkillGroupBox* skillGroupBox = nullptr;
        SkillDetailGroupBox* skillDetailGroupBox = nullptr;
        QBoxLayout* updateWidgetLayout = nullptr;

        std::shared_ptr<SkillManagerWrapper> memory = nullptr;

        PeriodicUpdateWidget* updateWidget = nullptr;

        SkillDescriptionWidget* skillDescriptionWidget = nullptr;
    };
} // namespace armarx::skills::gui

#endif // SKILLMEMORYGUI_H
