#include "SkillExecutionTreeWidgetItem.h"

namespace armarx::skills::gui
{
    SkillExecutionTreeWidgetItem*
    SkillExecutionTreeWidgetItem::SearchRecursiveForMatch(SkillExecutionTreeWidgetItem* haystack,
                                                          const SkillExecutionID& needle)
    {
        if (!haystack)
        {
            return nullptr;
        }

        if (needle == haystack->executionId)
        {
            return haystack;
        }
        for (int i = 0; i < haystack->childCount(); ++i)
        {
            auto el = dynamic_cast<SkillExecutionTreeWidgetItem*>(haystack->child(i));
            if (!el)
            {
                // Dynamic casting failed. Skip element...
                // We assume, that only this type can contain children in the tree.
                continue;
            }
            return SkillExecutionTreeWidgetItem::SearchRecursiveForMatch(el, needle);
        }
        return nullptr;
    }

    SkillExecutionID
    SkillExecutionTreeWidgetItem::getExecutionId()
    {
        return this->executionId;
    }
} // namespace armarx::skills::gui
