#ifndef SKILLEXECUTIONTREEWIDGETITEM_H
#define SKILLEXECUTIONTREEWIDGETITEM_H

#include <QTreeWidgetItem>

#include <RobotAPI/libraries/skills/core/SkillExecutionID.h>
#include <RobotAPI/libraries/skills/core/SkillStatusUpdate.h>

#include "../memory/MemoryCommunicatorBase.h"
#include "SkillExecutionTreeWidgetItem.h"

namespace armarx::skills::gui
{
    class SkillExecutionTreeWidgetItem : public QTreeWidgetItem, public MemoryCommunicatorBase
    {
    public:
        SkillExecutionTreeWidgetItem() = delete;

        // After constructing an item, it must be manually inserted into the tree!
        SkillExecutionTreeWidgetItem(const skills::SkillExecutionID& id,
                                     std::shared_ptr<SkillManagerWrapper> _memory) :
            MemoryCommunicatorBase(_memory), executionId(id)
        {
        }

        static SkillExecutionTreeWidgetItem*
        SearchRecursiveForMatch(SkillExecutionTreeWidgetItem* haystack,
                                const skills::SkillExecutionID& needle);

        skills::SkillExecutionID getExecutionId();

    protected:
        skills::SkillExecutionID executionId;


    private:
        void setupUi();
    };
} // namespace armarx::skills::gui

#endif // SKILLEXECUTIONTREEWIDGETITEM_H
