#ifndef SKILLDETAILGROUPBOX_H
#define SKILLDETAILGROUPBOX_H

#include <QGroupBox>
#include <QPushButton>
#include <QVBoxLayout>

#include "RobotAPI/libraries/skills_gui/aron_tree_widget/widgets/SkillDescriptionWidget.h"

#include "../memory/MemoryCommunicatorBase.h"
#include "ProfileMenuWidget.h"
#include "SkillDetailsTreeWidget.h"

namespace armarx::skills::gui
{
    class SkillDetailGroupBox : public QGroupBox, public MemoryCommunicatorBase
    {
    public:
        static const constexpr char* EXECUTE_SKILL_BUTTON_TEXT = "Request Execution";
        static const constexpr char* GROUP_BOX_TITLE = "Skill Description";

        SkillDetailGroupBox(std::shared_ptr<SkillManagerWrapper> _memory,
                            QWidget* parent = nullptr) :
            QGroupBox(parent), MemoryCommunicatorBase(_memory)
        {
            setupUi();
        }

    private:
        void setupUi();
        QVBoxLayout* layout = nullptr;
        QPushButton* executeSkillButton = nullptr;
        SkillDetailsTreeWidget* skillDetailsTreeWidget = nullptr;
        SkillDescriptionWidget* descriptionWidget = nullptr;
        ProfileMenuWidget* profileMenuWidget = nullptr;
    };
} // namespace armarx::skills::gui

#endif // SKILLDETAILGROUPBOX_H
