#ifndef SKILLGROUPBOX_H
#define SKILLGROUPBOX_H

#include <QGroupBox>
#include <QLineEdit>
#include <QPushButton>

#include "../memory/MemoryCommunicatorBase.h"
#include "SkillTreeWidget.h"

namespace armarx::skills::gui
{
    class SkillGroupBox : public QGroupBox, public MemoryCommunicatorBase
    {
        Q_OBJECT
    public:
        SkillGroupBox(std::shared_ptr<SkillManagerWrapper> _memory, QWidget* parent = nullptr) :
            QGroupBox(parent), MemoryCommunicatorBase(_memory)
        {
            setupUi();
        }

    signals:
        /**
         * Output signal to controller.
         */
        void searchRequest(std::string search);
    private slots:
        /**
         * Takes string from line edit and emits the search request.
         */
        void handleSearch();

    private:
        void setupUi();
        void connectSignals();
        QLineEdit* searchBar = nullptr;
        QPushButton* acceptSearchButton = nullptr;
        SkillTreeWidget* skillTreeWidget = nullptr;
    };
} // namespace armarx::skills::gui

#endif // SKILLGROUPBOX_H
