#ifndef ARMARX_SKILLS_GUI_SKILLTREEWIDGET_H
#define ARMARX_SKILLS_GUI_SKILLTREEWIDGET_H

#include <QTreeWidget>

#include <RobotAPI/libraries/skills/core/SkillID.h>

#include "../memory/MemoryCommunicatorBase.h"

namespace armarx::skills::gui
{
    class SkillTreeWidget : public QTreeWidget, public MemoryCommunicatorBase
    {
    public:
        SkillTreeWidget(std::shared_ptr<SkillManagerWrapper> _memory, QWidget* parent = nullptr) :
            QTreeWidget(parent), MemoryCommunicatorBase(_memory)
        {
        }

        struct SelectedSkill
        {
            skills::SkillID skillId;

            // make default constructable
            SelectedSkill() :
                skillId({.providerId = std::nullopt, .skillName = skills::SkillID::UNKNOWN})
            {
            }
        };

        SelectedSkill& getSelectedSkill();

    private slots:
        void skillSelectionChanged(QTreeWidgetItem* current, QTreeWidgetItem* previous);
        void updateSkills();

    private:
        SelectedSkill selectedSkill;
    };

} // namespace armarx::skills::gui

#endif // ARMARX_SKILLS_GUI_SKILLTREEWIDGET_H
